pre{
	'This is the minimal example for the problem with the missing '+
 	'stereotype property.'.println();
}
// Compare the elements with stereotype "ProblemStatement": if both the 
// stereotype properties named 'problem' and 'context' have the same property
// values, then the Class with the stereotype "ProblemStatement" of the two
// models are matching.
rule ProblemStatement
	match  l : Left!Class with r: Right!Class {
	guard: l.hasStereotype("ProblemStatement") = true and
		   r.hasStereotype("ProblemStatement") = true
	compare {
		("Comparation starts...").println();
		var lf_doMatch      = false;
		var l_left_problem  = null;
		var l_left_context  = null;
		var l_right_problem = null;
		var l_right_context = null;
        // Read stereotype property value of left problem statement class:
        for (l_left_stereotype in l.getAppliedStereotypes()){
			if (l_left_stereotype.name = "ProblemStatement"){
				// ************************************************************* 
				// in the following, all ownedAttributes of the left class are
				// output - no hint to the property value field here ;-((
				// *************************************************************
				l_left_stereotype.ownedAttributes.println();
	    		for (l_left_attribute in l_left_stereotype.ownedAttributes){
	    			if (l_left_attribute.name = "problem"){
	    				l_left_attribute.name.println();
	    				// in the following is a trial - however, the lowerValue
	    				// seems not to be the correct stereotype property value
	    				// field:
	    				l_left_problem = l_left_attribute.lowerValue;
	    				l_left_problem.println();
	    			}
	    			else if (l_left_attribute.name = "context"){
	    			    l_left_attribute.name.println();
	    				// in the following, only the defaultValue is used,
	    				// which is correctly returned - however, no clue which
	    				// field contains the actual value:
	    				l_left_context = l_left_attribute.defaultValue;
	    				l_left_context.println();
	    			}
	    		}
	    	}
	    }
	    for (l_right_stereotype in r.getAppliedStereotypes()){
	        // ***************************************************************** 
			// in the following, all ownedAttributes of the right class are
			// output - no hint to the property value field here ;-((
			// *****************************************************************
	        l_right_stereotype.ownedAttributes.println();
			if (l_right_stereotype.name = "ProblemStatement"){
	    		for (l_right_attribute in l_right_stereotype.ownedAttributes){
	    			if (l_right_attribute.name = "problem"){
	    			    l_right_attribute.name.println();
	    				l_right_problem = l_right_attribute.defaultValue;
	    				l_right_problem.println();
	    			}
	    			else if (l_right_attribute.name = "context"){
	    			    l_right_attribute.name.println();
	    				l_right_context = l_right_attribute.lowerValue;
	    				l_right_context.println();
	    			}
	    		}
	    	}
	    }
		if (l_left_problem = l_right_problem and
			l_left_context = l_right_context){
			lf_doMatch = true;
		}
		else{
			lf_doMatch = false;
		}
		if (lf_doMatch = false){
			return false;
		}
		else if (lf_doMatch = true){
			return true;
		}
	}
}
////////////////////////////////////////////////////////////////////////////////
// Check whether the left model element has a given stereotype applied 
////////////////////////////////////////////////////////////////////////////////
operation Left!Class hasStereotype(name:String):Boolean {
	var lf_HasStereotype = false;
	for (stereotype in self.getAppliedStereotypes()){
		if (stereotype.name = name){
	    	lf_HasStereotype = true;
	    	break;
	    }
	    else if (stereotype.name <> name){
	    	lf_HasStereotype = false;
	    	continue;
	    }
	}
	if (lf_HasStereotype = true){
		return true;
	}
	if (lf_HasStereotype = false){
		return false;
	}
}
////////////////////////////////////////////////////////////////////////////////
// Check whether the right model element has a given stereotype applied 
////////////////////////////////////////////////////////////////////////////////
operation Right!Class hasStereotype(name:String):Boolean {
	var lf_HasStereotype = false;
	for (stereotype in self.getAppliedStereotypes()){
		if (stereotype.name = name){
	    	lf_HasStereotype = true;
	    	break;
	    }
	    else if (stereotype.name <> name){
	    	lf_HasStereotype = false;
	    	continue;
	    }
	}
	if (lf_HasStereotype = true){
		return true;
	}
	if (lf_HasStereotype = false){
		return false;
	}
}
post{
	("Result Left: "  + matchTrace.matches.left).println();
	("Result Right: " + matchTrace.matches.right).println();
	("Matches? "      + matchTrace.matches.matching).println();
}